define(["element"], function (element) {
    "use strict";

    var transition;

    /**
     * Transition
     * Determines if current browser supports CSS transitions
     * And if so, assigns the proper transition event
     *
     * @return {Object}
     */
    transition = function () {
        var t,
            type,
            supported   = false,
            el          = element.create("fakeelement"),
            transitions = {
                "WebkitTransition" : "webkitTransitionEnd",
                "MozTransition"    : "transitionend",
                "OTransition"      : "otransitionend",
                "transition"       : "transitionend"
            };

        for (t in transitions) {
            if (el.style[t] !== undefined) {
                type      = transitions[t];
                supported = true;
                break;
            }
        }

        return {
            type      : type,
            supported : supported
        };
    };

    return transition();
});
